#ifndef xalloc_h
#define xalloc_h
#include <stdio.h>

typedef long AllocNum;
typedef long AllocMagic;
typedef size_t AllocSize;

void *chk_malloc(AllocSize size);
void chk_free(void * block);
void * chk_realloc(void * block, AllocSize size);
char * chk_strdup(char const * str);
void * chk_calloc(AllocSize nmemb, AllocSize size);

#ifndef xalloc_c

#ifdef DEB

#if defined(malloc)
#undef malloc
#undef calloc
#endif

#define malloc chk_malloc
#define free chk_free
#define realloc chk_realloc
#define strdup chk_strdup
#define calloc chk_calloc

#else

#define omalloc malloc
#define ofree free
#define orealloc realloc
#define ostrdup strdup
#define ocalloc calloc

#endif

#endif

/*
#define safe_realloc(ptr, size) \
(((ptr) == NULL) ? malloc(size) : realloc((ptr), (size)))
*/


#endif
